/*
 *
 * 80592.h
 *
 *  Cabealhos e declaraes para as rotinas do 80592.
 *
 */

/*
 * 
 * Estruturas de dados
 *
 */



/*

  Mensagem CAN

  */
typedef struct { 
  unsigned int ID;				/* ID da mensagem */
  unsigned char RTR;			/* RTR */
  unsigned char DLC;			/* Data Length Code */
  unsigned char* dados;			/* Dados */
} CANMess;


/*

 Protocolos

 */

extern void timer_ini(
			   unsigned char ID,          /* Identificao do timer (0,1) */
			   unsigned char CT,          /* 1=Conter, 0=Timer */
			   unsigned char MODE,        /* Modo do contador: 0,1,2 ou 3 */
			   unsigned char GATE,        /* Controlo do contador: 0 controlado
						 s pelo bit TRx; 1 controlado por
						 TRx e INTx */
			   unsigned char INTGER,      /* Gerao de interrupt */
			   unsigned char PRI,         /* Prioridade do interrupt (0 ou 1) */
			   unsigned char RECARGA);	/* Valor de recarga para o timer
						   (s modo 2) */

extern void timer_arranque(
			unsigned char ID,	/* Identificao do timer (0 ou 1) */
            unsigned char Ordem); /* Ordem: 0 paragem, 1 arranque */

extern void timer2_ini(unsigned char T2ER,	/* Enable Reset */
					   unsigned char T2P, /* Registo Pre-Scaler */
					   unsigned char T2M);	/* Modo de funcionamento */

extern void timer2_int( unsigned char OV, /* overflow interrupt */
						unsigned char CM, /* comparator register interrupts */
						unsigned char CT);	/* capture register interrupts */

extern void timer2_capcon(unsigned char Reg,    /* Identificao do registo */
						  unsigned char Modo);  /* Modo de funcionamento */


extern void RS232_ini(unsigned char Reload, /* valor de recarga timer 1 */
					  unsigned char Smod, /* programao do bit SMOD (PCON) */
					  unsigned char Rec); /* comando da recepo */


extern char CANenvia(CANMess *);
extern char CANrecebe(CANMess *);
void CANcodif(CANMess MensCAN,
               unsigned char trama[]);
void CANdecod(CANMess* pMensCAN,
               unsigned char trama[]);
char CANrec_trama(unsigned char *trama);
char CANenv_trama(unsigned char *trama);

